=== debian/changelog ===
cgal (4.6-2ubuntu2) wily; urgency=medium

  * debian/libcgal11.install.armhf: Account for architecture in path (as done
    in main install files).

 -- Logan Rosen <logan@ubuntu.com>  Sat, 09 May 2015 03:09:00 +0100

cgal (4.6-2ubuntu1) wily; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - {libcgal11,libcgal-qt4-11,libcgal-dev,libcgal-qt4-dev}.install.armhf:
      + Don't install files that dont't build on armhf due to GL/GLES skew.
  * Move install files to reflect new package names.
  * Change armhf install files to reflect changes in main ones.

 -- Logan Rosen <logan@ubuntu.com>  Sat, 09 May 2015 00:31:56 +0100

cgal (4.6-2) unstable; urgency=medium

  * Upload to unstable.

 -- Joachim Reichel <reichel@debian.org>  Mon, 27 Apr 2015 20:15:39 +0200

cgal (4.6-1) experimental; urgency=medium

  * New upstream release.
  * Rename binary packages libcgal10/libcgal-qt4-10 to
    libcgal11/libcgal-qt4-11 to reflect SONAME change.
  * Adjust lintian overrides to multiarch paths.

 -- Joachim Reichel <reichel@debian.org>  Fri, 10 Apr 2015 19:44:58 +0200

cgal (4.5.2-1) experimental; urgency=medium

  * New upstream release.

 -- Joachim Reichel <reichel@debian.org>  Fri, 20 Feb 2015 20:08:26 +0100

cgal (4.5.1-1) experimental; urgency=medium

  * New upstream release.

 -- Joachim Reichel <reichel@debian.org>  Mon, 29 Dec 2014 11:47:44 +0100

cgal (4.5-5) experimental; urgency=medium

  * Really drop Multi-Arch: no from libcgal-ipelets (Closes: #767516).

 -- Joachim Reichel <reichel@debian.org>  Fri, 07 Nov 2014 21:30:45 +0100

cgal (4.5-4) experimental; urgency=medium

  * Drop Multi-Arch: no from libcgal-ipelets since it causes problems with
    apt-get in wheezy (bug #759099). The value "no" is the default anyway
    (Closes: #767516).

 -- Joachim Reichel <reichel@debian.org>  Fri, 31 Oct 2014 19:26:48 +0100

cgal (4.5-3) experimental; urgency=medium

  * Add multiarch support based on a patch from Marc Glisse
    (Closes: #737307).
  * Add libtbb-dev to Suggests: of libcgal-dev and libcgal-demo.

 -- Joachim Reichel <reichel@debian.org>  Thu, 30 Oct 2014 21:31:46 +0100

cgal (4.5-2ubuntu1) vivid; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - {libcgal10,libcgal-qt4-10,libcgal-dev,libcgal-qt4-dev}.install.armhf:
      + Don't install files that dont't build on armhf due to GL/GLES skew.

 -- Logan Rosen <logan@ubuntu.com>  Thu, 06 Nov 2014 11:14:08 -0500

cgal (4.4-1ubuntu1) utopic; urgency=medium

  * Merge from Debian unstable (LP: #1155806). Remaining changes:
    - {libcgal10,libcgal-qt4-10,libcgal-dev,libcgal-qt4-dev}.install.armhf:
      + Don't install files that dont't build on armhf due to GL/GLES skew.

 -- Logan Rosen <logan@ubuntu.com>  Sat, 26 Apr 2014 15:38:22 -0400
